package   cohy.correlator;

import 	  rsf.vector.*;
import  juice.util.Tester;
import  juice.vector.*;
/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class CorrelatorTest {
  public static void main(String[] args) {

    boolean correct = true;

    System.out.println("1-D test");
    Rsf rand1 = RsfFactory.newRsf(55);
    rand1.rand();
    RealVec oput1 = new RealVec();
    Correlator auto1 = new Correlator(rand1);
    auto1.image(rand1, oput1);
    if (oput1.getValue() !=  1.f) correct = false;
    System.out.println("correlation should be  1: " + oput1.getValue());

    Rsf1 iput1 = (Rsf1) RsfFactory.newRsf(3);
    Rsf1 sgnl1 = (Rsf1) RsfFactory.newRsf(3);
    iput1.d[0] =  3.f; sgnl1.d[0] = -1.f;    
    iput1.d[1] =  2.f; sgnl1.d[1] =  0.f;
    iput1.d[2] =  5.f; sgnl1.d[2] =  1.f;
    Correlator cross1 = new Correlator(sgnl1);
    cross1.image(iput1,oput1);
    if (oput1.getValue() >=  0.229417f) correct = false;
    if (oput1.getValue() <=  0.229415f) correct = false;
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + oput1.getValue());

    System.out.println("2-D test");
    Rsf rand2 = RsfFactory.newRsf(22,32);
    rand2.rand();
    RealVec oput2 = new RealVec();
    Correlator auto2 = new Correlator(rand2);
    auto2.image(rand2, oput2);
    if (oput2.getValue() !=  1.f) correct = false;
    System.out.println("correlation should be  1: " + oput2.getValue());

    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(3,2);
    Rsf2 sgnl2 = (Rsf2) RsfFactory.newRsf(3,2);
    iput2.d[0][0] =  3.f; sgnl2.d[0][0] = -1.f;    
    iput2.d[0][1] =  2.f; sgnl2.d[0][1] =  0.f;
    iput2.d[0][2] =  5.f; sgnl2.d[0][2] =  1.f;
    iput2.d[1][0] =  3.f; sgnl2.d[1][0] = -1.f;    
    iput2.d[1][1] =  2.f; sgnl2.d[1][1] =  0.f;
    iput2.d[1][2] =  5.f; sgnl2.d[1][2] =  1.f;
    Correlator cross2 = new Correlator(sgnl2);
    cross2.image(iput2,oput2);
    if (oput2.getValue() >=  0.229417f) correct = false;
    if (oput2.getValue() <=  0.229415f) correct = false;
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + oput2.getValue());

    System.out.println("3-D test");
    Rsf rand3 = RsfFactory.newRsf(12,13,3);
    rand3.rand();
    RealVec oput3 = new RealVec();
    Correlator auto3 = new Correlator(rand3);
    auto3.image(rand3, oput3);
    if (oput3.getValue() !=  1.f) correct = false;
    System.out.println("correlation should be  1: " + oput3.getValue());

    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(3,2,2);
    Rsf3 sgnl3 = (Rsf3) RsfFactory.newRsf(3,2,2);
    iput3.d[0][0][0] =  3.f; sgnl3.d[0][0][0] = -1.f;    
    iput3.d[0][0][1] =  2.f; sgnl3.d[0][0][1] =  0.f;
    iput3.d[0][0][2] =  5.f; sgnl3.d[0][0][2] =  1.f;
    iput3.d[0][1][0] =  3.f; sgnl3.d[0][1][0] = -1.f;    
    iput3.d[0][1][1] =  2.f; sgnl3.d[0][1][1] =  0.f;
    iput3.d[0][1][2] =  5.f; sgnl3.d[0][1][2] =  1.f;
    iput3.d[1][0][0] =  3.f; sgnl3.d[1][0][0] = -1.f;    
    iput3.d[1][0][1] =  2.f; sgnl3.d[1][0][1] =  0.f;
    iput3.d[1][0][2] =  5.f; sgnl3.d[1][0][2] =  1.f;
    iput3.d[1][1][0] =  3.f; sgnl3.d[1][1][0] = -1.f;    
    iput3.d[1][1][1] =  2.f; sgnl3.d[1][1][1] =  0.f;
    iput3.d[1][1][2] =  5.f; sgnl3.d[1][1][2] =  1.f;
    Correlator cross3 = new Correlator(sgnl3);
    cross3.image(iput3,oput3);
    if (oput3.getValue() >=  0.229417f) correct = false;
    if (oput3.getValue() <=  0.229415f) correct = false;
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + oput3.getValue());

    Tester.exit(correct);
  }
}

