package   cohy.estDip;

import 	  rsf.vector.*;
import  juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DipEstimatorTest {
  public static void main(String[] args) {

    boolean correct = true;

    int[] dx = {DipEstimator.DX}; 
    int[] dy = {DipEstimator.DY}; 
    int[] dz = {DipEstimator.DZ}; 

    System.out.println("2-D test");
    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(2,2);
    iput2.d[0][0] =  1.f;    iput2.d[1][0] =  3.f;
    iput2.d[0][1] =  2.f;    iput2.d[1][1] =  4.f;

    DipEstimator dipy2 = new DipEstimator((RsfSpace) iput2.getSpace());
    Rsf          oput2 = (Rsf) dipy2.getRange().newMember();
    dipy2.image(iput2,oput2); 

    if (oput2.getDatum(dx) != -2) correct = false;
    System.out.println("dx should be -2: " + oput2.getDatum(dx));
    if (oput2.getDatum(dy) !=  1) correct = false;
    System.out.println("dy should be  1: " + oput2.getDatum(dy));

    System.out.println("3-D test");
    int[] smpl = {2,2,2}; 
    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(smpl);
    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   2.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;

    DipEstimator dipy3 = new DipEstimator((RsfSpace) iput3.getSpace());
    Rsf          oput3 = (Rsf) dipy3.getRange().newMember();
    dipy3.image(iput3,oput3); 

    if (oput3.getDatum(dx) !=  1) correct = false;
    System.out.println("dx should be  1: " + oput3.getDatum(dx));
    if (oput3.getDatum(dy) !=  1) correct = false;
    System.out.println("dy should be  1: " + oput3.getDatum(dy));
    if (oput3.getDatum(dz) !=  1) correct = false;
    System.out.println("dz should be  1: " + oput3.getDatum(dz));

    System.out.println("3-D test");
    iput3.d[0][0][0] =  -1.f;    iput3.d[1][0][0] =  -1.f;
    iput3.d[0][1][0] =  -1.f;    iput3.d[1][1][0] =  -1.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   1.f;
    iput3.d[0][1][1] =   1.f;    iput3.d[1][1][1] =   1.f;

    dipy3 = new DipEstimator((RsfSpace) iput3.getSpace());
    oput3 = (Rsf) dipy3.getRange().newMember();
    dipy3.image(iput3,oput3); 

    if (oput3.getDatum(dx) !=  0) correct = false;
    System.out.println("dx should be  0: " + oput3.getDatum(dx));
    if (oput3.getDatum(dy) !=  0) correct = false;
    System.out.println("dy should be  0: " + oput3.getDatum(dy));
    if (oput3.getDatum(dz) !=  1) correct = false;
    System.out.println("dz should be  1: " + oput3.getDatum(dz));

    System.out.println("3-D test");
    iput3.d[0][0][0] =   1.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   2.f;    iput3.d[1][1][0] =   2.f;
    iput3.d[0][0][1] =   3.f;    iput3.d[1][0][1] =   3.f;
    iput3.d[0][1][1] =   4.f;    iput3.d[1][1][1] =   4.f;

    dipy3 = new DipEstimator((RsfSpace) iput3.getSpace());
    oput3 = (Rsf) dipy3.getRange().newMember();
    dipy3.image(iput3,oput3); 

    if (oput3.getDatum(dx) !=  0) correct = false;
    System.out.println("dx should be  0: " + oput3.getDatum(dx));
    if (oput3.getDatum(dy) != .5) correct = false;
    System.out.println("dy should be .5: " + oput3.getDatum(dy));
    if (oput3.getDatum(dz) !=  1) correct = false;
    System.out.println("dz should be  1: " + oput3.getDatum(dz));

    Tester.exit(correct);
  }
}

