package   cohy.estDip;

import 	  rsf.vector.*;
import  juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DipXGradNormTest {
  public static void main(String[] args) {

    int[] ind2 = {0, 0   };
    int[] ind3 = {0, 0, 0};

    boolean correct = true;

    System.out.println("2-D test");
    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(2,2);
    iput2.d[0][0] =  1.f;    iput2.d[1][0] =  3.f;
    iput2.d[0][1] =  2.f;    iput2.d[1][1] =  4.f;

    iput2.d[0][0] =  1.f;    iput2.d[1][0] =   1.f;
    iput2.d[0][1] = -1.f;    iput2.d[1][1] =  -1.f;

    DipXGradNorm op2 = new DipXGradNorm((RsfSpace) iput2.getSpace());
    Rsf          oput2 = (Rsf) op2.getRange().newMember();
    op2.image(iput2,oput2); 

    if (oput2.getDatum(ind2) !=  0) correct = false;
    System.out.println("res is  0: " + oput2.getDatum(ind2));

    System.out.println("3-D test");
    int[] smpl = {2,2,2}; 
    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(smpl);

    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   2.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;
    /*
    iput3.d[0][0][0] =   1.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   1.f;
    iput3.d[0][0][1] =  -1.f;    iput3.d[1][0][1] =  -1.f;
    iput3.d[0][1][1] =  -1.f;    iput3.d[1][1][1] =  -1.f;
    */
    DipXGradNorm op3 = new DipXGradNorm((RsfSpace) iput3.getSpace());
    Rsf          oput3 = (Rsf) op3.getRange().newMember();
    
    op3.image(iput3,oput3); 
    if (oput3.getDatum(ind3) !=  0) correct = false;
    System.out.println("res norm is  0: " + oput3.getDatum(ind3));

    System.err.println("Sample (1,1,0) deviates from plane-wave");
    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =  12.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;

    op3.image(iput3,oput3); 
    if (oput3.getDatum(ind3) >= 9.83026e-07f) correct = false;
    if (oput3.getDatum(ind3) <= 9.83024e-07f) correct = false;
    System.out.println("res norm is 9.83025e-07: "+ oput3.getDatum(ind3));

    // delete everything until next comment
    /* 
    Rsf fieldIn = RsfFactory.newRsf("plane.HH");
    DipXGradNorm fieldOper = new DipXGradNorm((RsfSpace) fieldIn.getSpace());
    Rsf fieldOut            = (Rsf) fieldOper.getRange().newMember();
    
    fieldOper.image(fieldIn,fieldOut); 
    */ // including this comment

    Tester.exit(correct);
  }
}

