package   cohy.estWave;

import 	  sep.operator.*;
import  juice.operator.*;
import    jam.vector.*;
import 	  rsf.vector.*;
import   cohy.estDip.*;
import   cohy.correlator.*;

/**
 * Given an input Rsf, this operator 
 * estimates the least-square plane-wave dip of the input, 
 * stacks the input perpendicular to the dip direction to a single trace, 
 * spreads the single trace to a vector of the same space as the input, 
 * and finally correlates the individual traces of the input and 
 * backprojected plane-wave volume.<BR>  
 * 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ProProCor extends SepOperator{
  ProPro           pro; 
  TraceToTraceCorr cor; 

  public ProProCor(RsfSpace iputSpace) {
    super(iputSpace);
    this.pro = new ProPro(iputSpace);
  }
  protected ProProCor(ProProCor src) {
    super(src);
    pro = (ProPro)           src.pro.copy();
    cor = (TraceToTraceCorr) src.cor.copy();
  }
  public jam.JamObject copy() { return new ProProCor(this);}

  protected void apply(boolean add, Vector iput, Vector oput) {
    pro.image(iput,oput); 
    cor = new TraceToTraceCorr((Rsf) iput);
    cor.image(oput,oput); 
  }
}


