package   cohy.estWave;

import 	  sep.operator.*;
import  juice.operator.*;
import    jam.vector.*;
import 	  rsf.vector.*;
import   cohy.estDip.*;
import    rsf.operator.*;

/**
 * Given an input Rsf, this operator 
 * estimates the least-square plane-wave dip of the input, 
 * stacks the input perpendicular to the dip direction to a single trace, 
 * spreads the single trace to a vector of the same space as the input, 
 * and finally substracts the input and the backprojected plane-wave 
 * component. All tasks but the subtraction are accomplished by a ProPro 
 * operator.<BR>  
 * 
 * There must be a more elegant way of writing this. 
 * See jam/paper on Factories. 
 * 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ProProSub extends SepOperator{
  ProPro pro; 

  public ProProSub(RsfSpace iputSpace) {
    super(iputSpace, iputSpace);
    this.pro = new ProPro(iputSpace); 
  }
  protected ProProSub(ProProSub src) {
    super(src);
    pro = (ProPro) src.pro.copy();
  }
  public jam.JamObject copy() { return new ProProSub(this);}

  protected void apply(boolean add, Vector iput, Vector oput) {
    pro.image(iput,oput); 
    oput.sub(iput); // Only line that does something! Otherwise ProPro pro. 
  }
}


