package  cohy.gradient;

import 	  jam.vector.*;
import 	  jam.operator.*;
import 	  rsf.vector.*;
import    rsf.operator.*;
import    sep.io.*;
import    conv.convi.*;

public class Gradient2d { 
  /**
   * Computes \sqrt{f_x^2 + f_y^2} from finite difference 
   * approximations for f_x and f_y.  
   * Should probably offer
   * energy normalization and partial derivative mask as 
   * option. 
   */
  public static void main(String[] args) { 
    ArgumentKeeper command = new ArgumentKeeper(args);

    Rsf iput = (Rsf2) RsfFactory.newRsf(System.in); 

    Rsf dx = PartDiff2d.getDerivativeDx();
    Rsf dt = PartDiff2d.getDerivativeDt(); // should be dy instead of dt.

    InternalConvolution myInternalConvolution =
      new InternalConvolution( InternalConvolution.kInput , 
			       (RsfSpace) iput.getSpace(),
			       InternalConvolution.kFilter,
			       (RsfSpace) dx.getSpace());

    /*
    // This was nice but wasteful: my machine ran out of memory. 
    Rsf dxIput = (Rsf) myInternalConvolution.imageBinary(iput, dx);
    Rsf dyIput = (Rsf) myInternalConvolution.imageBinary(iput, dy);
    Rsf dzIput = (Rsf) myInternalConvolution.imageBinary(iput, dz);

    Rsf grad = (Rsf) dxIput.getSpace().newMember();
    dxIput.mul(dxIput); grad.add(dxIput);
    dyIput.mul(dyIput); grad.add(dyIput);
    dzIput.mul(dzIput); grad.add(dzIput);
    */

    Rsf dIput; 
    Rsf grad = (Rsf) myInternalConvolution.getRange().newMember();
    dIput = (Rsf) myInternalConvolution.imageBinary(iput, dx);
    dIput.mul(dIput); grad.add(dIput);
    dIput = (Rsf) myInternalConvolution.imageBinary(iput, dt);
    dIput.mul(dIput); grad.add(dIput);
    ElwSqrt.elwSqrt(grad, grad);
    grad.write(System.out); 
  }
}
