package  cohy.patch3d;

import   jam.vector.*;
import   rsf.vector.*;
import   rsf.solver.*;
import   conv.convi.*;
import   sep.io.ArgumentKeeper;
import juice.solver.*;
import   gag.xtp.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class MissingFilterDemo {
  public static void main(String[] args) {
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    String in  = argKeeper.getString("in" , "../Data/make.HH");
    String out = argKeeper.getString("out", "testout.H");

    Rsf data = new Rsf(in);

    int[] pefSize = { 5, 3 };
    int[] filtOne = { 2, 0 };

    Rsf  pefKnown = getPefKnown   (pefSize, filtOne);
    Mask freeMask = getPefFreeMask(pefSize, filtOne);

    Rsf  filter   = (Rsf) pefKnown.getSpace().newMember();

    MissingFilter.getMissingFilter(data, pefKnown, freeMask, filter,
				   1e-8F, 40);
    filter.add(pefKnown);

    InternalConvolution
      conv = new InternalConvolution(InternalConvolution.kInput ,
				     (RsfSpace) data  .getSpace(),
				     InternalConvolution.kFilter,
				     (RsfSpace) filter.getSpace());
    Rsf filtered = (Rsf) conv.imageBinary(data, filter);

    RsfCanvas canv1 = new RsfCanvas(data,     300, 300, -0.25F, 0.25F);
    RsfCanvas canv2 = new RsfCanvas(filtered, 300, 300,
                                    -1.6e-7F, 1.6e-7F);
    RsfCanvas canv3 = new RsfCanvas(filter,   60,   60, -1.1F, 1.1F);
    ResultFrame resFrame = new ResultFrame("Results", canv1);
    resFrame.add(canv2);
    resFrame.add(canv3);
    resFrame.resize(600, 800);
    resFrame.show();

    filtered.write(out);
    filter  .write("testfilter.H");
  }

  static Rsf  getPefKnown   (int[] pefSize, int[] filtOne) {
    Rsf pef = new Rsf(pefSize);
    pef.zero();
    pef.setDatum(filtOne, 1F);
    return pef;
  }

  static Mask getPefFreeMask(int[] pefSize, int[] filtOne) {
    Rsf mask = new Rsf(pefSize);
    mask.fill(1F);
    int n = mask.i(filtOne);
    // This loop depends on the structure of rsfF.vector.Rsf and
    // would be more complicated with rsfA.vector.Rsf
    for (int i = 0; i <= n; i++)
      mask.d[i] = 0F;
    return new SepMask(mask);
  }
}
